<template>
    <div class="order-request-execution">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Изменить"
        :is-loading="isLoading"
        data-qa="ChangeTarifModal"
        @submit="onSubmitHandler"
      >
        <div class="title">Укажите новый тариф</div>
        <ObCheckbox
          v-if="formData.assignedTariff && formData.assignedTariff.vatRate"
          v-model="formData.isVatInclude"
          label="Тарифы указываются с учетом НДС"
          data-qa="isVatInclude"
        />
        <div class="row row-inputs">
          <div class="col-xs-6">
            <ObInput
              :value="order.baseServicePrice || order.totalPrice"
              :label="'Текущий тариф' + (isVatPayer ? '' : ', НДС не облагается')"
              :readonly=true
              type="money:2"
              sub-title="₽"
            />
          </div>
          <div
            v-if="isVatPayer && currentVatVariants"
            class="col-xs-6"
          >
            <ObSelect
              :value="formData.assignedTariff && formData.assignedTariff.vatRate"
              :items="currentVatVariants"
              value-exp="value"
              label="НДС"
              :disabled="true"
            />
          </div>
          <div class="col-xs-6">
            <ObInput
              :value="formData.tariff"
              :label="'Новый тариф' + (isVatPayer ? '' : ', НДС не облагается')"
              type="money:2"
              placeholder="Введите тариф"
              sub-title="₽"
              @input="onInputTariff"
            />
          </div>
        </div>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          multiple
          :upload-method="uploadMethod"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'
import debounce from "debounce"

export default {
  name: 'ChangeTariffModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObInput,
    ObUploader,
    ObCheckbox,
    ObSelect
  },
  props: {
    order: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      isLoading: false,
      participantInfo: {}
    }
  },
  watch: {
    'order.contractorUuid': {
      immediate: true,
      handler (value) {
        this.getParticipantInfo(value)
      }
    },
    'formData.fileUuids' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    }
  },
  computed: {
    ...mapGetters({}),
    formModel () {
      let _self = this

      return {
        uuid: {
          value: () => _self.order.uuid
        },
        fileUuids: {
          value: ''
        },
        tariff: {
          value: '',
          validator: {
            required
          }
        },
        suborderSpecies: {
          value: () => _self.order.suborderSpecies,
          validator: {
            required
          }
        },
        isVatInclude: {
          value: () => Boolean(_self.order.isVatInclude)
        },
        vat: {
          value: () => _self.order.orderTotalAmount.vatRate + '%'
        },
        assignedTariff: {
          nested_fields: {
            vatPrice: {
              value: 0
            },
            vatRate: {
              value: 0
            },
            vatType: {
              value: 'NO_VAT'
            }
          }
        }
      }
    },
    isVatPayer () {
      return Boolean(this.participantInfo.isVatPayer)
    },
    isVatCharged () {
      return this.order.service?.isVatCharged || this.order.service?.isVatCharged === undefined
    },
    isInternational () {
      return ['FOREIGN', 'CROSSBOARDING'].includes(this.transboundary)
    },
    transboundary () {
      return this.order.suborderSpecies?.transboundary
    },
    routeCategory () {
      return this.order.suborderSpecies?.routeCategory
    },
    currentVatVariants () {
      if (!this.isVatPayer || this.formData.assignedTariff?.vatType === 'NO_VAT') {
        return null
      }

      return [
        {
          title: '0%',
          value: 0
        },
        {
          title: '20%',
          value: 20
        }
      ]
    },
    uploadMethod () {
      return api.files.postFile
    }
  },
  methods: {
    async afterInitForm () {
      this.getParticipantInfo(this.order.contractorUuid)
    },
    async onUploadHandler (data) {
      if (!data || !data.length) {
        this.formData.fileUuids = null
        return
      }

      this.formData.fileUuids = data.map(item => item.uuid)
    },
    async onSubmitHandler (data) {
      data.tariff = data.isVatInclude ? data.assignedTariff.priceWithVat : data.assignedTariff.priceWithoutVat
      try {
        this.isLoading = true
        await api.orderProcess.changeTariff({ ...data })
        this.$emit('on-submitted')
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка смены тарифа'
        })
      } finally {
        this.isLoading = false
      }
    },
    async getParticipantInfo (uuid) {
      let participantInfo = {}

      if (uuid) {
        participantInfo = await api.orderProcess.getPaticipantInfo({ uuid })
      }

      this.participantInfo = participantInfo

      this.$nextTick(() => {
        this.setVatParams()
      })
    },
    onInputTariff: debounce(async function(value) {
      this.formData.tariff = value
      await this.calcTariff(value)
    }, 500),
    async calcTariff (value) {
      if (this.formData.assignedTariff.vatRate) {
        const postData = {
          vatRate: this.formData.assignedTariff.vatRate,
          quantity: 1
        }

        if (this.formData.assignedTariff.vatRate && this.formData.isVatInclude) {
          postData.priceWithVat = value
        } else {
          postData.priceWithoutVat = value
        }
        let { totalWithoutVat, totalWithVat, totalVat } = await api.orderProcess.vatCalculation({ list: [postData] })

        this.formData.assignedTariff.priceWithoutVat = totalWithoutVat
        this.formData.assignedTariff.priceWithVat = totalWithVat
        this.formData.assignedTariff.vatPrice = totalVat
      } else {
        this.formData.assignedTariff.priceWithoutVat = value
        this.formData.assignedTariff.priceWithVat = value
        this.formData.assignedTariff.vatPrice = 0
      }
    },
    async setVatParams () {
      const { vatType, vatRate } = this.order.orderTotalAmount || { vatType: 'NO_VAT', vatRate: 0 }

      this.formData.assignedTariff.vatType = vatType
      this.formData.assignedTariff.vatRate = vatRate
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 10px!important;
      margin-bottom: 20px!important;
    }
    &::v-deep {
      .ob-input-wrap {
        margin-bottom: 10px;
      }
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
</style>
